/*  testcpp.cpp
 * Copyright (C) 2012, Andres Abeliuk, all rights reserved.
 *
 * Andres Abeliuk <aabeliuk@dcc.uchile.cl>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#include <ctime>
#include <cstdlib>
#include <string.h>
#include "SuffixTREE_RLCSA.h"
//#include "Repair.h"


using namespace CSA;
using namespace std;
using namespace cds_utils;
using namespace cds_static;

SuffixTREE_RLCSA * saveLoad(SuffixTREE_RLCSA * bs, char* name) {
        char* file = name;
        strcat(file, ".tmp");
	ofstream ofs(file);
	bs->save(ofs, name);
	ofs.close();
          cout << "cst saved"<< endl;
	ifstream ifs(file);
	SuffixTREE_RLCSA * ret = SuffixTREE_RLCSA::load(ifs, name);
	ifs.close();
	return ret;
}

SuffixTREE_RLCSA * saveLoadSA_LCP(SuffixTREE_RLCSA * bs, char* name) {
        char* file = name;
        strcat(file, ".tmp");
	ofstream ofs(file);
	bs->saveSA_LCP(ofs, name);
	ofs.close();
          cout << "cst saved"<< endl;
	ifstream ifs(file);
	SuffixTREE_RLCSA * ret = SuffixTREE_RLCSA::loadSA_LCP(ifs, name);
	ifs.close();
	return ret;
}

SuffixTREE_RLCSA * Load(char* name) {
	char* file = name;
        strcat(file, ".tmp");
        ifstream ifs(file);
	SuffixTREE_RLCSA * ret = SuffixTREE_RLCSA::load(ifs , name);
	ifs.close();
	return ret;
}

SuffixTREE_RLCSA * LoadSA_LCP(char* name) {
	char* file = name;
        strcat(file, ".tmp");
        ifstream ifs(file);
	SuffixTREE_RLCSA * ret = SuffixTREE_RLCSA::loadSA_LCP(ifs , name);
	ifs.close();
	return ret;
}

void saveNPR(SuffixTREE_RLCSA * bs, char* name) {
        char* file = name;
        strcat(file, ".tmp");
	ofstream ofs(file);
	bs->saveNPR(ofs, name);
	ofs.close();
         cout << "cst saved"<< endl;
}
SuffixTREE_RLCSA * LoadNPR(char* name, int trim) {
	char* file = name;
        strcat(file, ".tmp");
        ifstream ifs(file);
	SuffixTREE_RLCSA * ret = SuffixTREE_RLCSA::loadNPR(ifs , name, trim);
	ifs.close();
	return ret;
}

bool testSuffixTREE_RLCSA(SuffixTREE_RLCSA *s1){
	/*add any test you want*/

    size_t vl=0;
    size_t vr=0;
    size_t fchild_l=0;
    size_t fchild_r=0;
    size_t parent_l=0;
    size_t parent_r=0;
    size_t nsibling_l=0;
    size_t nsibling_r=0;
    char l;
    size_t depth;

    cout << "Size: " << s1->getSize() << endl;

    s1->Root(&vl, &vr);
    cout << "Root: " << vl << ", " << vr << endl;

   // s1->Child(vl, vr,'a', &fchild_l, &fchild_r );
   //  cout << "Child a: " << fchild_l << ", " << fchild_r << endl;

    // s1->Child(fchild_l, fchild_r,'a', &fchild_l, &fchild_r );
    //cout << "Child a: " << fchild_l << ", " << fchild_r << endl;

    size_t leaves = s1->Count(vl, vr);
    cout << "Leaves: " << leaves << endl;

    s1->FChild(vl, vr, &fchild_l, &fchild_r );
    cout << "Fchild: " << fchild_l << ", " << fchild_r << endl;

    if(s1->Ancestor(vl, vr, fchild_l, fchild_r))
        cout << "Root is ancestor of: " << fchild_l << ", " << fchild_r << endl;

    s1->NSibling(fchild_l, fchild_r, &nsibling_l, &nsibling_r);
     cout << "Sibling of fchild: " << nsibling_l << ", " << nsibling_r << endl;

    s1->Parent(nsibling_l, nsibling_r, &parent_l, &parent_r);
    cout << "parent of nsibling: " << parent_l << ", " << parent_r << endl;

    l = s1->Letter(nsibling_l,nsibling_r, 1);
    cout << "Letter from nsibling: " << l << endl;

    depth= s1->SDepth(fchild_l,fchild_r);
     cout << "String depth: " << depth <<  endl;



    return true;
}
SuffixTREE_RLCSA * buildNPR(char* name){
    SuffixTREE_RLCSA *cst;

    char* file = name;
    strcat(file, ".tmp");
    ifstream ifs(file);
    RLCSA *csa = RLCSA::load(name);
    LCP_RLCSA *lcp = LCP_RLCSA::load(ifs);

    SuffixTREE_RLCSA csty(lcp, csa, RPBal_NPR, 32);
    cst = saveLoad(&csty, name);

    return cst;
}
int random(int lowest, int highest ){

    return (rand() % highest) + lowest;

}

bool testPerformance(SuffixTREE_RLCSA * cst){
    clock_t begin, end;
    double timeP=0, timeS=0;
    int op=0;
    int node;
    size_t vl=0;
    size_t vr=0;
    size_t parent_l=0;
    size_t parent_r=0;
    size_t depth;

    cst->Root(&vl, &vr);
    size_t n = cst->Count(vl, vr);
    srand((unsigned)time(0)); //seed

    for(size_t i= 0; i<1000; ++i){
        node = random(0,n-1);
        cst->Parent(node, node, &parent_l, &parent_r);

        while(parent_l!=0 && parent_r!=n-1){
            ++op;
            begin=clock();
            cst->Parent(parent_l, parent_r, &parent_l, &parent_r);
            end=clock();
            timeP += (end-begin);

            begin=clock();
            depth = cst->SDepth(parent_l,parent_r);
            end=clock();
            timeS += (end-begin);
            //cout << "String depth: " << depth <<  endl;
        }

    }
    timeP = (timeP*1000)/CLOCKS_PER_SEC;
    timeS = (timeS*1000)/CLOCKS_PER_SEC;
    cout << "Operations: " << op  <<  endl;
    cout << "Mean parent: " << timeP/op  <<  endl;
    cout << "Mean Sdepth: " << timeS/op  <<  endl;

    return true;
}

bool testLCP(SuffixTREE_RLCSA * cst, size_t npr_type){
    clock_t begin, end;
    int node;
    double time1=0;
    double var1=0;
    int op=0;
    size_t vl=0;
    size_t vr=0;
    
    cst->Root(&vl, &vr);
    size_t n = cst->Count(vl, vr);
    cout << "N: " << n  <<  endl;



    srand((unsigned)time(0)); //seed
	int i;

       //for(i= 300482000; i<429265759; i+=429260){
       for(i= 0; i<10000000; i+=1){
	if(i%1000000==0){	
		cout <<"i: "<< i << endl;
		//cout <<"op: "<< op << endl;
	}
        node = random(0,n-1);

	++op;
	begin=clock();
	cst->LCP(node);
	end=clock();
	var1 += (end-begin)*(end-begin);
	time1 += (end-begin);

    }
    
    time1 /= op;
    var1 /= op;
    var1 -= time1*time1;  
    var1 = sqrt(var1);
    var1 = var1*1000/CLOCKS_PER_SEC; 

    time1 = (time1*1000)/CLOCKS_PER_SEC;


    cout << "Operations: " << op  <<  endl;
    cout << "Mean LCP: " << time1  <<  endl;
    cout << "Var LCP: " << var1 <<  endl;
	
    return true;
}


bool testNPR(SuffixTREE_RLCSA * cst, size_t npr_type){
    clock_t begin, end;
    double time1=0, time2=0, time3=0;
    double var1=0, var2=0, var3=0;
    int op=0;
    int node, node2;
    size_t vl=0;
    size_t vr=0;


    cst->Root(&vl, &vr);
    size_t n = cst->Count(vl, vr);
    cout << "N: " << n  <<  endl;

    if(npr_type==CN_NPR) cout << "CN NPR:" <<  endl;
    if(npr_type==RPBal_NPR) cout << "RP NPR:" <<  endl;

    srand((unsigned)time(0)); //seed
    for(size_t i= 0; i<100000; ++i){
        node = random(0,n-1);
        node2 = random(0,n-1);
 
        ++op;
        begin=clock();
        cst->NSV(node);
        end=clock();
        var1 += (end-begin)*(end-begin);
        time1 += (end-begin);

        begin=clock();
        cst->PSV(node);
        end=clock();
        var2 += (end-begin)*(end-begin);
        time2 += (end-begin);

        begin=clock();
        cst->RMQ(node,node2);
        end=clock();
        var3 += (end-begin)*(end-begin);
        time3 += (end-begin);

    }
    time1 /= op;
    var1 /= op;
    var1 -= time1*time1;  
    var1 = sqrt(var1);
    var1 = var1*1000/CLOCKS_PER_SEC; 


    time2 /= op;
    var2 /= op;
    var2 -= time2*time2;
    var2 = sqrt(var2);
    var2 = var2*1000/CLOCKS_PER_SEC;

    time3 /= op;
    var3 /= op;
    var3 -= time3*time3;
    var3 = sqrt(var3);
    var3 = var3*1000/CLOCKS_PER_SEC;

    time1 = (time1*1000)/CLOCKS_PER_SEC;
    time2 = (time2*1000)/CLOCKS_PER_SEC;
    time3 = (time3*1000)/CLOCKS_PER_SEC;

    cout << "Operations: " << op  <<  endl;
    cout << "Mean NSV: " << time1  <<  endl;
    cout << "Var NSV: " << var1 <<  endl;
    cout << "Mean PSV: " << time2  <<  endl;
    cout << "Var PSV: " << var2 <<  endl;
    cout << "Mean RMQ: " << time3  <<  endl;
    cout << "Var RMQ: " << var3 <<  endl;

    return true;
}



int main(int argc, char *argv[]){
	char *text, *name, *options;
	size_t length, npr_type;


	if(argc < 2) {
		cout << "Checks if the SuffixTREE_RLCSA of the file <arch> is save/load correctly"  << endl;
		cout << "usage: " << argv[0] << " <arch> [options]" << endl;
                cout << "[options]: " << argv[0] << " -l : load SuffixTree" << endl;
                cout << "[options]: " << argv[0] << " -c : create from LCP and RLCSA" << endl;
		return 0;
	}

        name = argv[1];
        SuffixTREE_RLCSA *csty;
        
        //parameter
        npr_type = RPBal_NPR;

        if(argc == 3){

            options = argv[2];

            if (strcmp(options, "-l") == 0 ){

                cout << "Loading Suffix tree" << endl;
                csty	= Load(name);

               // csty->test_lcp();

                cout << "Size " << csty->getSize() << endl;

            }
            else if (strcmp(options, "-S") == 0 ){

                cout << "CReating SA and LCP" << endl;

                 if(loadText(name, &text, &length))
                    return 1;

                //create index              //FMN_RRR_OS  SAD_GON_OS 
                SuffixTREE_RLCSA *cst = new SuffixTREE_RLCSA(text, length, FMN_RRR_OS,  npr_type, 128);
                csty = saveLoadSA_LCP(cst, name);
                //csty->test_lcp();
               // testSuffixTREE_RLCSA(&csty);

                delete [] text;

            }
            else if (strcmp(options, "-c")==0){

                cout << "Loading SA & LCP" << endl;
                csty	= LoadSA_LCP(name);

                char* file = name;
                SuffixTREE_RLCSA *cst = new SuffixTREE_RLCSA(csty->lcp, csty->csa, npr_type, 16 );

                csty = saveLoad(cst, file);

                cout << "Size " << csty->getSize() << endl;

            }
            else if (strcmp(options, "-n")==0){

                cout << "Full NPR" << endl;
                csty	= LoadSA_LCP(name);


                char* file = name;
                SuffixTREE_RLCSA *cst = new SuffixTREE_RLCSA(csty->lcp, csty->csa, RPBal_NPR);

                saveNPR(cst, file);

                return 0;
            }
            else if (strcmp(options, "-t")==0){

                cout << "TRIMMING NPR" << endl;
                csty	= LoadNPR(name, 8);

                char* file = name;
                csty = saveLoad(csty, file);

                cout << "Size " << csty->getSize() << endl;

            }

        }else {
             cout << "Creating Suffix tree from text" << endl;

            if(loadText(name, &text, &length))
                    return 1;

            //create index              //FMN_RRR_OS  SAD_GON_OS
            SuffixTREE_RLCSA *cst = new SuffixTREE_RLCSA(text, length, FMN_RRR_OS, npr_type, 2);
	  
	    csty = saveLoad(cst, name);
            //csty->test_lcp();
           // testSuffixTREE_RLCSA(&csty);

            delete [] text;

        }

	if(!testNPR(csty, npr_type)) {
		cerr << "ERROR TESTING SuffixTREE_RLCSAY" << endl;
		return -1;
	}

	delete (SuffixTREE_RLCSA *)csty;
	cout << "SuffixTREE_RLCSA_Y OK\n" << endl;


	return 0;
}



